// generated by Fast Light User Interface Designer (fluid) version 1.0308

#include "gui.hpp"
#include "script.hpp"
#include "debugger.hpp"
#include <vector>
#include <FL/Fl_Text_Buffer.H>

void Plus4EmuGUI_DebugWindow::cb_window_i(Fl_Double_Window*, void*) {
  {
  if (breakPointEditor->changed()) {
    breakPointEditor->clear_changed();
    breakPointEditor->do_callback();
  }
  focusWidget = (Fl_Widget *) 0;
  gui.vm.setSingleStepMode(0);
  this->hide();
};
}
void Plus4EmuGUI_DebugWindow::cb_window(Fl_Double_Window* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->user_data()))->cb_window_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_debugTabs_i(Fl_Tabs* o, void*) {
  {
  if (prvTab == monitorTab)
    updateWindow();
  prvTab = o->value();
};
}
void Plus4EmuGUI_DebugWindow::cb_debugTabs(Fl_Tabs* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->user_data()))->cb_debugTabs_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_searchStringValuator_i(Fl_Input* o, void*) {
  {
  if (o->value()) {
    try {
      std::vector<std::string>  args;
      {
        std::string tmp("H ");
        tmp += o->value();
        Plus4EmuGUIMonitor::tokenizeString(args, tmp.c_str());
      }
      int32_t addr = monitor_->searchPattern(
          args, 1, args.size() - 1,
          memoryDumpViewAddress + 1U, memoryDumpViewAddress,
          memoryDumpCPUAddressMode);
      if (addr >= 0) {
        memoryDumpViewAddress = uint32_t(addr);
        updateMemoryDumpDisplay();
      }
      else
        throw Plus4Emu::Exception("Search string not found");
    }
    catch (std::exception& e) {
      gui.errorMessage(e.what());
    }
  }
};
}
void Plus4EmuGUI_DebugWindow::cb_searchStringValuator(Fl_Input* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_searchStringValuator_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_Find_i(Fl_Button*, void*) {
  {
  searchStringValuator->do_callback();
};
}
void Plus4EmuGUI_DebugWindow::cb_Find(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Find_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_CPU_i(Fl_Light_Button* o, void*) {
  {
  memoryDumpCPUAddressMode = (o->value() != 0);
  updateMemoryDumpDisplay();
};
}
void Plus4EmuGUI_DebugWindow::cb_CPU(Fl_Light_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_CPU_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_memoryDumpStartAddressValuator_i(Fl_Input* o, void*) {
  {
  if (parseHexNumber(memoryDumpStartAddress, o->value()) > 0L) {
    if (memoryDumpStartAddress != memoryDumpViewAddress) {
      memoryDumpViewAddress = memoryDumpStartAddress;
      updateMemoryDumpDisplay();
    }
  }
};
}
void Plus4EmuGUI_DebugWindow::cb_memoryDumpStartAddressValuator(Fl_Input* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_memoryDumpStartAddressValuator_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_memoryDumpEndAddressValuator_i(Fl_Input* o, void*) {
  {
  parseHexNumber(memoryDumpEndAddress, o->value());
  updateMemoryDumpDisplay();
};
}
void Plus4EmuGUI_DebugWindow::cb_memoryDumpEndAddressValuator(Fl_Input* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_memoryDumpEndAddressValuator_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_memoryDumpPrvPageButton_i(Fl_Button* o, void*) {
  {
  if (o->value() != 0) {
    memoryDumpAddrDec = 0x003FFF80U;
  }
  else {
    memoryDumpViewAddress =
        (memoryDumpViewAddress + memoryDumpAddrDec) & 0x003FFFFFU;
    memoryDumpAddrDec = 0x003FFFC0U;
    updateMemoryDumpDisplay();
  }
};
}
void Plus4EmuGUI_DebugWindow::cb_memoryDumpPrvPageButton(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_memoryDumpPrvPageButton_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb__i(Fl_Button*, void*) {
  {
  if (memoryDumpStartAddress != memoryDumpViewAddress) {
    memoryDumpViewAddress = memoryDumpStartAddress;
    updateMemoryDumpDisplay();
  }
};
}
void Plus4EmuGUI_DebugWindow::cb_(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb__i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_memoryDumpNxtPageButton_i(Fl_Button* o, void*) {
  {
  if (o->value() != 0) {
    memoryDumpAddrInc = 0x00000080U;
  }
  else {
    memoryDumpViewAddress =
        (memoryDumpViewAddress + memoryDumpAddrInc) & 0x003FFFFFU;
    memoryDumpAddrInc = 0x00000040U;
    updateMemoryDumpDisplay();
  }
};
}
void Plus4EmuGUI_DebugWindow::cb_memoryDumpNxtPageButton(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_memoryDumpNxtPageButton_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_ASCII_i(Fl_Light_Button* o, void*) {
  {
  memoryDumpASCIIFileFormat = (o->value() != 0);
};
}
void Plus4EmuGUI_DebugWindow::cb_ASCII(Fl_Light_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_ASCII_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_Load_i(Fl_Button*, void*) {
  {
  std::FILE *f = (std::FILE *) 0;
  try {
    std::string tmp;
    if (gui.browseFile(tmp, gui.debuggerDirectory,
                       "All files\t*", Fl_Native_File_Chooser::BROWSE_FILE,
                       "Load memory")) {
      f = Plus4Emu::fileOpen(tmp.c_str(), "rb");
      if (!f)
        throw Plus4Emu::Exception("cannot open file");
      if (memoryDumpASCIIFileFormat) {
        tmp = "";
        while (true) {
          int   c = std::fgetc(f);
          if (c == EOF)
            break;
          if (char(c) != '\0')
            tmp += char(c);
        }
        parseMemoryDump(tmp.c_str());
      }
      else {
        uint32_t  addr = memoryDumpStartAddress;
        uint32_t  addrMask = uint32_t(memoryDumpCPUAddressMode ? 0x00FFFFU : 0x3FFFFFU);
        while (true) {
          int   c = std::fgetc(f);
          if (c == EOF)
            break;
          gui.vm.writeMemory(addr, uint8_t(c & 0xFF), memoryDumpCPUAddressMode);
          if (((addr ^ memoryDumpEndAddress) & addrMask) == 0U)
            break;
          addr++;
        }
      }
      std::fclose(f);
    }
  }
  catch (std::exception& e) {
    if (f)
      std::fclose(f);
    gui.errorMessage(e.what());
  }
  updateWindow();
};
}
void Plus4EmuGUI_DebugWindow::cb_Load(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Load_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_Save_i(Fl_Button*, void*) {
  {
  std::FILE *f = (std::FILE *) 0;
  try {
    std::string tmp;
    if (gui.browseFile(tmp, gui.debuggerDirectory,
                       "All files\t*",
                       Fl_Native_File_Chooser::BROWSE_SAVE_FILE,
                       "Save memory")) {
      if (memoryDumpASCIIFileFormat)
        f = Plus4Emu::fileOpen(tmp.c_str(), "w");
      else
        f = Plus4Emu::fileOpen(tmp.c_str(), "wb");
      if (!f)
        throw Plus4Emu::Exception("cannot open file");
      if (memoryDumpASCIIFileFormat) {
        dumpMemory(tmp, memoryDumpStartAddress, memoryDumpEndAddress,
                   0U, false, memoryDumpCPUAddressMode);
        tmp += '\n';
        for (size_t i = 0; i < tmp.length(); i++) {
          if (std::fputc(tmp[i], f) == EOF)
            throw Plus4Emu::Exception("error writing file - is the disk full ?");
        }
      }
      else {
        uint32_t  addr = memoryDumpStartAddress;
        uint32_t  addrMask = uint32_t(memoryDumpCPUAddressMode ? 0x00FFFFU : 0x3FFFFFU);
        while (true) {
          uint8_t c = gui.vm.readMemory(addr, memoryDumpCPUAddressMode);
          if (std::fputc(c, f) == EOF)
            throw Plus4Emu::Exception("error writing file - is the disk full ?");
          if (((addr ^ memoryDumpEndAddress) & addrMask) == 0U)
            break;
          addr++;
        }
      }
      std::fclose(f);
    }
  }
  catch (std::exception& e) {
    if (f)
      std::fclose(f);
    gui.errorMessage(e.what());
  }
};
}
void Plus4EmuGUI_DebugWindow::cb_Save(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Save_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_disassemblyStartAddressValuator_i(Fl_Input* o, void*) {
  {
  if (parseHexNumber(disassemblyStartAddress, o->value()) > 0L)
    disassemblyViewAddress = disassemblyStartAddress;
  updateDisassemblyDisplay();
};
}
void Plus4EmuGUI_DebugWindow::cb_disassemblyStartAddressValuator(Fl_Input* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_disassemblyStartAddressValuator_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_disassemblyPrvPageButton_i(Fl_Button*, void*) {
  {
  disassemblyViewAddress = disassemblySearchBack(20);
  updateDisassemblyDisplay();
};
}
void Plus4EmuGUI_DebugWindow::cb_disassemblyPrvPageButton(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_disassemblyPrvPageButton_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_1_i(Fl_Button*, void*) {
  {
  if (disassemblyViewAddress != disassemblyStartAddress) {
    disassemblyViewAddress = disassemblyStartAddress;
    updateDisassemblyDisplay();
  }
};
}
void Plus4EmuGUI_DebugWindow::cb_1(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_1_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_disassemblyNxtPageButton_i(Fl_Button*, void*) {
  {
  disassemblyViewAddress = disassemblyNextAddress;
  updateDisassemblyDisplay();
};
}
void Plus4EmuGUI_DebugWindow::cb_disassemblyNxtPageButton(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_disassemblyNxtPageButton_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_PC_i(Fl_Button*, void*) {
  {
  disassemblyViewAddress = gui.vm.getProgramCounter();
  updateDisassemblyDisplay();
};
}
void Plus4EmuGUI_DebugWindow::cb_PC(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_PC_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_breakPointEditor_i(Fl_Text_Editor*, void*) {
  {
  applyBreakPointList();
};
}
void Plus4EmuGUI_DebugWindow::cb_breakPointEditor(Fl_Text_Editor* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_breakPointEditor_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_bpPriorityThresholdValuator_i(Fl_Value_Slider* o, void*) {
  {
  gui.config.debug.bpPriorityThreshold = int(o->value() + 0.5);
  gui.config.debugSettingsChanged = true;
  try {
    gui.config.applySettings();
  }
  catch (std::exception& e) {
    gui.errorMessage(e.what());
  }
};
}
void Plus4EmuGUI_DebugWindow::cb_bpPriorityThresholdValuator(Fl_Value_Slider* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_bpPriorityThresholdValuator_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_breakOnInvalidOpcodeValuator_i(Fl_Light_Button* o, void*) {
  {
  gui.config.debug.breakOnInvalidOpcode = (o->value() != 0);
  gui.config.debugSettingsChanged = true;
  try {
    gui.config.applySettings();
  }
  catch (std::exception& e) {
    gui.errorMessage(e.what());
  }
};
}
void Plus4EmuGUI_DebugWindow::cb_breakOnInvalidOpcodeValuator(Fl_Light_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_breakOnInvalidOpcodeValuator_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_Apply_i(Fl_Button*, void*) {
  {
  applyBreakPointList();
};
}
void Plus4EmuGUI_DebugWindow::cb_Apply(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Apply_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_Load1_i(Fl_Button*, void*) {
  {
  std::FILE *f = (std::FILE *) 0;
  try {
    std::string tmp;
    if (gui.browseFile(tmp, gui.debuggerDirectory,
                       "All files\t*", Fl_Native_File_Chooser::BROWSE_FILE,
                       "Load watchpoint definitions from file")) {
      f = Plus4Emu::fileOpen(tmp.c_str(), "rb");
      if (!f)
        throw Plus4Emu::Exception("cannot open file");
      tmp = "";
      bool  crFlag = false;
      while (true) {
        int   c = std::fgetc(f);
        if (crFlag) {
          crFlag = false;
          if (c == '\n')
            continue;
        }
        if (c == EOF)
          break;
        if (char(c) == '\0')
          continue;
        if (c == '\r') {
          tmp += '\n';
          crFlag = true;
        }
        else
          tmp += char(c);
      }
      std::fclose(f);
      f = (std::FILE *) 0;
      bpEditBuffer->text(tmp.c_str());
      Plus4Emu::BreakPointList  bpList(tmp);
      gui.vm.clearBreakPoints();
      gui.vm.setBreakPoints(bpList);
    }
  }
  catch (std::exception& e) {
    if (f)
      std::fclose(f);
    gui.errorMessage(e.what());
  }
};
}
void Plus4EmuGUI_DebugWindow::cb_Load1(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Load1_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_Save1_i(Fl_Button*, void*) {
  {
  std::FILE   *f = (std::FILE *) 0;
  const char  *buf = (char *) 0;
  try {
    std::string tmp;
    if (gui.browseFile(tmp, gui.debuggerDirectory,
                       "All files\t*",
                       Fl_Native_File_Chooser::BROWSE_SAVE_FILE,
                       "Save watchpoint definitions to file")) {
      f = Plus4Emu::fileOpen(tmp.c_str(), "w");
      if (!f)
        throw Plus4Emu::Exception("cannot open file");
      buf = bpEditBuffer->text();
      if (!buf)
        throw std::bad_alloc();
      const char  *bufp = buf;
      char        c = '\0';
      while ((*bufp) != '\0') {
        c = *(bufp++);
        if (std::fputc(c, f) == EOF)
          throw Plus4Emu::Exception("error writing file - is the disk full ?");
      }
      if (c != '\n') {
        if (std::fputc('\n', f) == EOF)
          throw Plus4Emu::Exception("error writing file - is the disk full ?");
      }
      std::free(const_cast<char *>(buf));
      std::fclose(f);
    }
  }
  catch (std::exception& e) {
    if (buf)
      std::free(const_cast<char *>(buf));
    if (f)
      std::fclose(f);
    gui.errorMessage(e.what());
  }
};
}
void Plus4EmuGUI_DebugWindow::cb_Save1(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Save1_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_Load2_i(Fl_Button*, void*) {
  {
  std::FILE *f = (std::FILE *) 0;
  try {
    std::string tmp;
    if (gui.browseFile(tmp, gui.debuggerDirectory,
                       "Lua scripts\t*.lua",
                       Fl_Native_File_Chooser::BROWSE_FILE,
                       "Load Lua script from file")) {
      f = Plus4Emu::fileOpen(tmp.c_str(), "rb");
      if (!f)
        throw Plus4Emu::Exception("cannot open file");
      tmp = "";
      bool  crFlag = false;
      while (true) {
        int   c = std::fgetc(f);
        if (crFlag) {
          crFlag = false;
          if (c == '\n')
            continue;
        }
        if (c == EOF)
          break;
        if (char(c) == '\0')
          continue;
        if (c == '\r') {
          tmp += '\n';
          crFlag = true;
        }
        else
          tmp += char(c);
      }
      std::fclose(f);
      f = (std::FILE *) 0;
      scriptEditBuffer->text(tmp.c_str());
    }
  }
  catch (std::exception& e) {
    if (f)
      std::fclose(f);
    gui.errorMessage(e.what());
  }
};
}
void Plus4EmuGUI_DebugWindow::cb_Load2(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Load2_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_Save2_i(Fl_Button*, void*) {
  {
  std::FILE   *f = (std::FILE *) 0;
  const char  *buf = (char *) 0;
  try {
    std::string tmp;
    if (gui.browseFile(tmp, gui.debuggerDirectory,
                       "Lua scripts\t*.lua",
                       Fl_Native_File_Chooser::BROWSE_SAVE_FILE,
                       "Save Lua script to file")) {
      f = Plus4Emu::fileOpen(tmp.c_str(), "w");
      if (!f)
        throw Plus4Emu::Exception("cannot open file");
      buf = scriptEditBuffer->text();
      if (!buf)
        throw std::bad_alloc();
      const char  *bufp = buf;
      char        c = '\0';
      while ((*bufp) != '\0') {
        c = *(bufp++);
        if (std::fputc(c, f) == EOF)
          throw Plus4Emu::Exception("error writing file - is the disk full ?");
      }
      if (c != '\n') {
        if (std::fputc('\n', f) == EOF)
          throw Plus4Emu::Exception("error writing file - is the disk full ?");
      }
      std::free(const_cast<char *>(buf));
      std::fclose(f);
    }
  }
  catch (std::exception& e) {
    if (buf)
      std::free(const_cast<char *>(buf));
    if (f)
      std::fclose(f);
    gui.errorMessage(e.what());
  }
};
}
void Plus4EmuGUI_DebugWindow::cb_Save2(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Save2_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_Insert_i(Fl_Button*, void* v) {
  {
  try {
    scriptEditBuffer->insert(luaScriptEditor->insert_position(),
                             "\nfunction breakPointCallback(d, t, a, v)\n"
                             "  return true\n"
                             "end\n");
  }
  catch (std::exception& e) {
    gui.errorMessage(e.what());
  }
};
}
void Plus4EmuGUI_DebugWindow::cb_Insert(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Insert_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_Run_i(Fl_Button*, void*) {
  {
  const char  *buf = (char *) 0;
  try {
    buf = scriptEditBuffer->text();
    if (!buf)
      throw std::bad_alloc();
    luaScript.loadScript(buf);
    std::free(const_cast<char *>(buf));
    buf = (char *) 0;
    if (debugContextValuator->value() >= 0)
      gui.vm.setDebugContext(debugContextValuator->value());
    updateWindow();
  }
  catch (std::exception& e) {
    if (buf)
      std::free(const_cast<char *>(buf));
    gui.errorMessage(e.what());
  }
};
}
void Plus4EmuGUI_DebugWindow::cb_Run(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Run_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_Stop_i(Fl_Button*, void*) {
  {
  luaScript.closeScript();
};
}
void Plus4EmuGUI_DebugWindow::cb_Stop(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->parent()->parent()->parent()->user_data()))->cb_Stop_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_debugContextValuator_i(Fl_Choice* o, void*) {
  {
  if (o->value() >= 0) {
    setDebugContext(o->value());
    updateWindow();
  }
};
}
void Plus4EmuGUI_DebugWindow::cb_debugContextValuator(Fl_Choice* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->user_data()))->cb_debugContextValuator_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_stepIntoButton_i(Fl_Button*, void*) {
  {
  focusWidget = stepButton;
  gui.vm.setSingleStepMode(4);
  this->deactivate();
};
}
void Plus4EmuGUI_DebugWindow::cb_stepIntoButton(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->user_data()))->cb_stepIntoButton_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_returnButton_i(Fl_Button*, void*) {
  {
  focusWidget = stepButton;
  gui.vm.setSingleStepMode(2);
  uint16_t  tmp = gui.vm.getStackPointer();
  uint32_t  tmp2 = gui.vm.readMemory(tmp, true)
                   | (uint32_t(gui.vm.readMemory((tmp - 0xFF) | 0x0100, true))
                      << 8);
  gui.vm.setSingleStepModeNextAddress(int32_t(tmp2 + 1U));
  this->deactivate();
};
}
void Plus4EmuGUI_DebugWindow::cb_returnButton(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->user_data()))->cb_returnButton_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_stepToButton_i(Fl_Button*, void*) {
  {
  uint32_t  tmp = 0U;
  if (parseHexNumber(tmp, stepToAddressValuator->value()) > 0L) {
    focusWidget = stepButton;
    gui.vm.setSingleStepMode(2);
    gui.vm.setSingleStepModeNextAddress(int32_t(tmp));
    this->deactivate();
  }
};
}
void Plus4EmuGUI_DebugWindow::cb_stepToButton(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->user_data()))->cb_stepToButton_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_stepToAddressValuator_i(Fl_Input* o, void*) {
  {
  uint32_t  tmp = 0U;
  parseHexNumber(tmp, o->value());
  tmp = tmp & 0xFFFFU;
  char    tmp2[16];
  std::sprintf(&(tmp2[0]), "%04X", (unsigned int) tmp);
  o->value(&(tmp2[0]));
};
}
void Plus4EmuGUI_DebugWindow::cb_stepToAddressValuator(Fl_Input* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->user_data()))->cb_stepToAddressValuator_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_stepOverButton_i(Fl_Button*, void*) {
  {
  focusWidget = stepButton;
  gui.vm.setSingleStepMode(2);
  this->deactivate();
};
}
void Plus4EmuGUI_DebugWindow::cb_stepOverButton(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->user_data()))->cb_stepOverButton_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_stepButton_i(Fl_Button*, void*) {
  {
  focusWidget = stepButton;
  gui.vm.setSingleStepMode(1);
  this->deactivate();
};
}
void Plus4EmuGUI_DebugWindow::cb_stepButton(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->user_data()))->cb_stepButton_i(o,v);
}

void Plus4EmuGUI_DebugWindow::cb_continueButton_i(Fl_Button*, void*) {
  {
  focusWidget = continueButton;
  gui.vm.setSingleStepMode(0);
  this->deactivate();
};
}
void Plus4EmuGUI_DebugWindow::cb_continueButton(Fl_Button* o, void* v) {
  ((Plus4EmuGUI_DebugWindow*)(o->parent()->user_data()))->cb_continueButton_i(o,v);
}

void Plus4EmuGUI_DebugWindow::createDebugWindow() {
  { window = new Fl_Double_Window(960, 720);
    window->color((Fl_Color)48);
    window->callback((Fl_Callback*)cb_window, (void*)(this));
    { debugTabs = new Fl_Tabs(10, 10, 940, 665);
      debugTabs->callback((Fl_Callback*)cb_debugTabs);
      { mainTab = new Fl_Group(10, 35, 940, 640, "Page 1");
        mainTab->box(FL_THIN_UP_BOX);
        { Fl_Group* o = new Fl_Group(20, 45, 515, 245);
          o->box(FL_THIN_UP_BOX);
          o->align(Fl_Align(FL_ALIGN_TOP_LEFT|FL_ALIGN_INSIDE));
          { Fl_Output* o = cpuRegisterDisplay = new Fl_Output(30, 70, 345, 80, "CPU registers");
            cpuRegisterDisplay->type(12);
            cpuRegisterDisplay->textfont(5);
            cpuRegisterDisplay->textcolor((Fl_Color)2);
            cpuRegisterDisplay->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            o->cursor_color(FL_BACKGROUND2_COLOR);
          } // Fl_Output* cpuRegisterDisplay
          { Fl_Output* o = memoryPagingDisplay = new Fl_Output(385, 70, 140, 80, "Memory paging");
            memoryPagingDisplay->type(12);
            memoryPagingDisplay->textfont(5);
            memoryPagingDisplay->textcolor((Fl_Color)2);
            memoryPagingDisplay->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            o->cursor_color(FL_BACKGROUND2_COLOR);
          } // Fl_Output* memoryPagingDisplay
          { Fl_Output* o = stackMemoryDumpDisplay = new Fl_Output(30, 175, 495, 105, "Stack");
            stackMemoryDumpDisplay->type(12);
            stackMemoryDumpDisplay->textfont(5);
            stackMemoryDumpDisplay->textcolor((Fl_Color)2);
            stackMemoryDumpDisplay->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            o->cursor_color(FL_BACKGROUND2_COLOR);
          } // Fl_Output* stackMemoryDumpDisplay
          o->end();
        } // Fl_Group* o
        { Fl_Group* o = new Fl_Group(545, 45, 395, 165);
          o->box(FL_THIN_UP_BOX);
          o->align(Fl_Align(FL_ALIGN_TOP_LEFT|FL_ALIGN_INSIDE));
          { Fl_Output* o = tedRegisterDisplay = new Fl_Output(555, 70, 375, 130, "TED registers");
            tedRegisterDisplay->type(12);
            tedRegisterDisplay->textfont(5);
            tedRegisterDisplay->textcolor((Fl_Color)2);
            tedRegisterDisplay->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            o->cursor_color(FL_BACKGROUND2_COLOR);
          } // Fl_Output* tedRegisterDisplay
          o->end();
        } // Fl_Group* o
        { Fl_Group* o = new Fl_Group(20, 300, 515, 365);
          o->box(FL_THIN_UP_BOX);
          o->align(Fl_Align(FL_ALIGN_TOP_LEFT|FL_ALIGN_INSIDE));
          { Fl_Input* o = searchStringValuator = new Fl_Input(30, 325, 375, 25, "Search");
            searchStringValuator->tooltip("The search string can be specified with the syntax used by the H and SR monit\
or commands");
            searchStringValuator->textfont(4);
            searchStringValuator->callback((Fl_Callback*)cb_searchStringValuator);
            searchStringValuator->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            searchStringValuator->when(FL_WHEN_ENTER_KEY_ALWAYS);
            o->cursor_color(Fl_Color(3));
          } // Fl_Input* searchStringValuator
          { Fl_Button* o = new Fl_Button(415, 325, 110, 25, "Find next");
            o->color(FL_LIGHT1);
            o->selection_color((Fl_Color)51);
            o->callback((Fl_Callback*)cb_Find);
          } // Fl_Button* o
          { Plus4EmuGUI_ScrollableOutput* o = memoryDumpDisplay = new Plus4EmuGUI_ScrollableOutput(30, 375, 375, 280, "Memory dump");
            memoryDumpDisplay->type(12);
            memoryDumpDisplay->box(FL_DOWN_BOX);
            memoryDumpDisplay->color(FL_BACKGROUND2_COLOR);
            memoryDumpDisplay->selection_color(FL_SELECTION_COLOR);
            memoryDumpDisplay->labeltype(FL_NORMAL_LABEL);
            memoryDumpDisplay->labelfont(0);
            memoryDumpDisplay->labelsize(14);
            memoryDumpDisplay->labelcolor(FL_FOREGROUND_COLOR);
            memoryDumpDisplay->textfont(5);
            memoryDumpDisplay->textcolor((Fl_Color)2);
            memoryDumpDisplay->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            memoryDumpDisplay->when(FL_WHEN_RELEASE);
            o->cursor_color(FL_BACKGROUND2_COLOR);
          } // Plus4EmuGUI_ScrollableOutput* memoryDumpDisplay
          { Fl_Light_Button* o = new Fl_Light_Button(415, 375, 110, 25, "CPU address");
            o->tooltip("Select if 16 bit CPU, or 22 bit physical addresses are to be used");
            o->value(1);
            o->color(FL_LIGHT1);
            o->selection_color((Fl_Color)3);
            o->callback((Fl_Callback*)cb_CPU);
          } // Fl_Light_Button* o
          { Fl_Input* o = memoryDumpStartAddressValuator = new Fl_Input(415, 420, 110, 25, "Start address");
            memoryDumpStartAddressValuator->textfont(4);
            memoryDumpStartAddressValuator->callback((Fl_Callback*)cb_memoryDumpStartAddressValuator);
            memoryDumpStartAddressValuator->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            o->cursor_color(Fl_Color(3));
            o->value("0000");
          } // Fl_Input* memoryDumpStartAddressValuator
          { Fl_Input* o = memoryDumpEndAddressValuator = new Fl_Input(415, 465, 110, 25, "End address");
            memoryDumpEndAddressValuator->tooltip("End address of memory dump (for file I/O only); this address is still include\
d");
            memoryDumpEndAddressValuator->textfont(4);
            memoryDumpEndAddressValuator->callback((Fl_Callback*)cb_memoryDumpEndAddressValuator);
            memoryDumpEndAddressValuator->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            o->cursor_color(Fl_Color(3));
            o->value("007F");
          } // Fl_Input* memoryDumpEndAddressValuator
          { memoryDumpPrvPageButton = new Fl_Button(415, 510, 35, 25, "@<");
            memoryDumpPrvPageButton->tooltip("View previous page");
            memoryDumpPrvPageButton->color(FL_LIGHT1);
            memoryDumpPrvPageButton->selection_color((Fl_Color)51);
            memoryDumpPrvPageButton->callback((Fl_Callback*)cb_memoryDumpPrvPageButton);
            memoryDumpPrvPageButton->when(FL_WHEN_CHANGED);
          } // Fl_Button* memoryDumpPrvPageButton
          { Fl_Button* o = new Fl_Button(455, 510, 30, 25, "@|<");
            o->tooltip("Return to start address");
            o->color(FL_LIGHT1);
            o->selection_color((Fl_Color)51);
            o->callback((Fl_Callback*)cb_);
          } // Fl_Button* o
          { memoryDumpNxtPageButton = new Fl_Button(490, 510, 35, 25, "@>");
            memoryDumpNxtPageButton->tooltip("View next page");
            memoryDumpNxtPageButton->color(FL_LIGHT1);
            memoryDumpNxtPageButton->selection_color((Fl_Color)51);
            memoryDumpNxtPageButton->callback((Fl_Callback*)cb_memoryDumpNxtPageButton);
            memoryDumpNxtPageButton->when(FL_WHEN_CHANGED);
          } // Fl_Button* memoryDumpNxtPageButton
          { Fl_Light_Button* o = new Fl_Light_Button(415, 555, 110, 25, "ASCII format");
            o->tooltip("Select if memory dump file format should be ASCII or binary");
            o->color(FL_LIGHT1);
            o->selection_color((Fl_Color)3);
            o->callback((Fl_Callback*)cb_ASCII);
          } // Fl_Light_Button* o
          { Fl_Button* o = new Fl_Button(415, 590, 110, 25, "Load from file");
            o->color(FL_LIGHT1);
            o->selection_color((Fl_Color)51);
            o->callback((Fl_Callback*)cb_Load);
          } // Fl_Button* o
          { Fl_Button* o = new Fl_Button(415, 625, 110, 25, "Save to file");
            o->color(FL_LIGHT1);
            o->selection_color((Fl_Color)51);
            o->callback((Fl_Callback*)cb_Save);
          } // Fl_Button* o
          o->end();
        } // Fl_Group* o
        { Fl_Group* o = new Fl_Group(545, 220, 395, 445);
          o->box(FL_THIN_UP_BOX);
          o->align(Fl_Align(FL_ALIGN_TOP_LEFT|FL_ALIGN_INSIDE));
          { Plus4EmuGUI_ScrollableOutput* o = disassemblyDisplay = new Plus4EmuGUI_ScrollableOutput(555, 230, 375, 380);
            disassemblyDisplay->type(12);
            disassemblyDisplay->box(FL_DOWN_BOX);
            disassemblyDisplay->color(FL_BACKGROUND2_COLOR);
            disassemblyDisplay->selection_color(FL_SELECTION_COLOR);
            disassemblyDisplay->labeltype(FL_NORMAL_LABEL);
            disassemblyDisplay->labelfont(0);
            disassemblyDisplay->labelsize(14);
            disassemblyDisplay->labelcolor(FL_FOREGROUND_COLOR);
            disassemblyDisplay->textfont(5);
            disassemblyDisplay->textcolor((Fl_Color)2);
            disassemblyDisplay->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            disassemblyDisplay->when(FL_WHEN_RELEASE);
            o->cursor_color(FL_BACKGROUND2_COLOR);
          } // Plus4EmuGUI_ScrollableOutput* disassemblyDisplay
          { Fl_Input* o = disassemblyStartAddressValuator = new Fl_Input(560, 630, 115, 25, "Start address");
            disassemblyStartAddressValuator->textfont(4);
            disassemblyStartAddressValuator->callback((Fl_Callback*)cb_disassemblyStartAddressValuator);
            disassemblyStartAddressValuator->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            o->cursor_color(Fl_Color(3));
            o->value("0000");
          } // Fl_Input* disassemblyStartAddressValuator
          { disassemblyPrvPageButton = new Fl_Button(685, 630, 55, 25, "@<");
            disassemblyPrvPageButton->tooltip("View previous page");
            disassemblyPrvPageButton->color(FL_LIGHT1);
            disassemblyPrvPageButton->selection_color((Fl_Color)51);
            disassemblyPrvPageButton->callback((Fl_Callback*)cb_disassemblyPrvPageButton);
          } // Fl_Button* disassemblyPrvPageButton
          { Fl_Button* o = new Fl_Button(745, 630, 55, 25, "@|<");
            o->tooltip("Return to start address");
            o->color(FL_LIGHT1);
            o->selection_color((Fl_Color)51);
            o->callback((Fl_Callback*)cb_1);
          } // Fl_Button* o
          { disassemblyNxtPageButton = new Fl_Button(805, 630, 55, 25, "@>");
            disassemblyNxtPageButton->tooltip("View next page");
            disassemblyNxtPageButton->color(FL_LIGHT1);
            disassemblyNxtPageButton->selection_color((Fl_Color)51);
            disassemblyNxtPageButton->callback((Fl_Callback*)cb_disassemblyNxtPageButton);
          } // Fl_Button* disassemblyNxtPageButton
          { Fl_Button* o = new Fl_Button(870, 630, 55, 25, "PC");
            o->tooltip("View code at the program counter");
            o->color(FL_LIGHT1);
            o->selection_color((Fl_Color)51);
            o->callback((Fl_Callback*)cb_PC);
          } // Fl_Button* o
          o->end();
        } // Fl_Group* o
        mainTab->end();
      } // Fl_Group* mainTab
      { monitorTab = new Fl_Group(10, 35, 940, 640, "Page 2");
        monitorTab->box(FL_THIN_UP_BOX);
        monitorTab->hide();
        { Fl_Group* o = new Fl_Group(20, 45, 530, 365);
          o->box(FL_THIN_UP_BOX);
          o->align(Fl_Align(FL_ALIGN_TOP_LEFT|FL_ALIGN_INSIDE));
          { Plus4EmuGUIMonitor* o = monitor_ = new Plus4EmuGUIMonitor(30, 55, 510, 345);
            monitor_->tooltip("Type ? for a list of available monitor commands, or ? CMD for help on command\
 CMD");
            monitor_->box(FL_DOWN_FRAME);
            monitor_->color(FL_BACKGROUND2_COLOR);
            monitor_->selection_color(FL_SELECTION_COLOR);
            monitor_->labeltype(FL_NORMAL_LABEL);
            monitor_->labelfont(0);
            monitor_->labelsize(14);
            monitor_->labelcolor(FL_FOREGROUND_COLOR);
            monitor_->textfont(5);
            monitor_->textcolor((Fl_Color)2);
            monitor_->align(Fl_Align(FL_ALIGN_TOP));
            monitor_->when(FL_WHEN_NEVER);
            o->setDebugger(*this);
            o->cursor_style(Fl_Text_Display::BLOCK_CURSOR);
            o->cursor_color(Fl_Color(3));
          } // Plus4EmuGUIMonitor* monitor_
          o->end();
        } // Fl_Group* o
        { Fl_Group* o = new Fl_Group(560, 45, 380, 365);
          o->box(FL_THIN_UP_BOX);
          o->align(Fl_Align(FL_ALIGN_TOP_LEFT|FL_ALIGN_INSIDE));
          { Fl_Text_Editor* o = breakPointEditor = new Fl_Text_Editor(570, 55, 360, 255);
            breakPointEditor->tooltip("Enter watchpoint definitions, separated by spaces or newlines. Allowed format\
s include NNNN (memory, CPU address), and NNNN:NN (TED video position as Y:X);\
 each N is a hexadecimal digit. Address ranges (separated by a - character) ca\
n also be specified. Use the following suffixes to check for read, write or ex\
ecute access only, set priority, or ignore watchpoints depending on the progra\
m counter: r, w, x, p0, p1, p2, p3, i.");
            breakPointEditor->box(FL_DOWN_BOX);
            breakPointEditor->textfont(4);
            breakPointEditor->callback((Fl_Callback*)cb_breakPointEditor);
            breakPointEditor->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            o->cursor_color(Fl_Color(3));
            o->buffer(bpEditBuffer);
            o->scrollbar_align(FL_ALIGN_RIGHT);
          } // Fl_Text_Editor* breakPointEditor
          { bpPriorityThresholdValuator = new Fl_Value_Slider(575, 331, 145, 23, "Priority threshold");
            bpPriorityThresholdValuator->type(1);
            bpPriorityThresholdValuator->color(FL_DARK1);
            bpPriorityThresholdValuator->selection_color(FL_LIGHT2);
            bpPriorityThresholdValuator->maximum(4);
            bpPriorityThresholdValuator->step(1);
            bpPriorityThresholdValuator->callback((Fl_Callback*)cb_bpPriorityThresholdValuator);
            bpPriorityThresholdValuator->align(Fl_Align(FL_ALIGN_TOP_LEFT));
          } // Fl_Value_Slider* bpPriorityThresholdValuator
          { breakOnInvalidOpcodeValuator = new Fl_Light_Button(780, 330, 145, 25, "Break on CPU jam");
            breakOnInvalidOpcodeValuator->color(FL_LIGHT1);
            breakOnInvalidOpcodeValuator->selection_color((Fl_Color)3);
            breakOnInvalidOpcodeValuator->callback((Fl_Callback*)cb_breakOnInvalidOpcodeValuator);
          } // Fl_Light_Button* breakOnInvalidOpcodeValuator
          { Fl_Button* o = new Fl_Button(575, 370, 145, 25, "Apply");
            o->tooltip("Reset watchpoints from text format definition");
            o->color(FL_LIGHT1);
            o->selection_color((Fl_Color)51);
            o->callback((Fl_Callback*)cb_Apply);
          } // Fl_Button* o
          { Fl_Button* o = new Fl_Button(780, 370, 65, 25, "Load");
            o->color(FL_LIGHT1);
            o->selection_color((Fl_Color)51);
            o->callback((Fl_Callback*)cb_Load1);
          } // Fl_Button* o
          { Fl_Button* o = new Fl_Button(860, 370, 65, 25, "Save");
            o->color(FL_LIGHT1);
            o->selection_color((Fl_Color)51);
            o->callback((Fl_Callback*)cb_Save1);
          } // Fl_Button* o
          o->end();
        } // Fl_Group* o
        { Fl_Group* o = new Fl_Group(20, 420, 920, 245);
          o->box(FL_THIN_UP_BOX);
          o->align(Fl_Align(FL_ALIGN_TOP_LEFT|FL_ALIGN_INSIDE));
          { Fl_Text_Editor* o = luaScriptEditor = new Fl_Text_Editor(30, 430, 740, 225);
            luaScriptEditor->tooltip("Lua script editor (for documentation, see the README file)");
            luaScriptEditor->box(FL_DOWN_BOX);
            luaScriptEditor->textfont(4);
            luaScriptEditor->align(Fl_Align(FL_ALIGN_TOP_LEFT));
            o->cursor_color(Fl_Color(3));
            o->buffer(scriptEditBuffer);
            o->scrollbar_align(FL_ALIGN_RIGHT);
          } // Fl_Text_Editor* luaScriptEditor
          { Fl_Button* o = new Fl_Button(780, 435, 145, 25, "Load from file");
            o->color(FL_LIGHT1);
            o->selection_color((Fl_Color)51);
            o->callback((Fl_Callback*)cb_Load2);
          } // Fl_Button* o
          { Fl_Button* o = new Fl_Button(780, 470, 145, 25, "Save to file");
            o->color(FL_LIGHT1);
            o->selection_color((Fl_Color)51);
            o->callback((Fl_Callback*)cb_Save2);
          } // Fl_Button* o
          { Fl_Button* o = new Fl_Button(780, 530, 145, 25, "Insert callback");
            o->tooltip("Insert breakpoint callback function template");
            o->color(FL_LIGHT1);
            o->selection_color((Fl_Color)51);
            o->callback((Fl_Callback*)cb_Insert);
          } // Fl_Button* o
          { Fl_Button* o = new Fl_Button(780, 590, 145, 25, "Run");
            o->tooltip("Run or restart the Lua script, and enable the breakpoint callback if it is de\
fined");
            o->color(FL_LIGHT1);
            o->selection_color((Fl_Color)51);
            o->callback((Fl_Callback*)cb_Run);
          } // Fl_Button* o
          { Fl_Button* o = new Fl_Button(780, 625, 145, 25, "Stop");
            o->tooltip("Disable the Lua breakpoint callback");
            o->color(FL_LIGHT1);
            o->selection_color((Fl_Color)51);
            o->callback((Fl_Callback*)cb_Stop);
          } // Fl_Button* o
          o->end();
        } // Fl_Group* o
        monitorTab->end();
      } // Fl_Group* monitorTab
      debugTabs->end();
    } // Fl_Tabs* debugTabs
    { Fl_Choice* o = debugContextValuator = new Fl_Choice(15, 685, 150, 25);
      debugContextValuator->down_box(FL_BORDER_BOX);
      debugContextValuator->callback((Fl_Callback*)cb_debugContextValuator);
      debugContextValuator->align(Fl_Align(FL_ALIGN_RIGHT));
      o->add("Main CPU|Unit 8|Unit 9|Unit 10|Unit 11|Printer");
      o->value(gui.vm.getDebugContext());
    } // Fl_Choice* debugContextValuator
    { stepIntoButton = new Fl_Button(330, 685, 80, 25, "Step into");
      stepIntoButton->selection_color(FL_LIGHT1);
      stepIntoButton->callback((Fl_Callback*)cb_stepIntoButton);
    } // Fl_Button* stepIntoButton
    { returnButton = new Fl_Button(420, 685, 80, 25, "Return");
      returnButton->selection_color(FL_LIGHT1);
      returnButton->callback((Fl_Callback*)cb_returnButton);
    } // Fl_Button* returnButton
    { stepToButton = new Fl_Button(510, 685, 80, 25, "Step to:");
      stepToButton->selection_color(FL_LIGHT1);
      stepToButton->callback((Fl_Callback*)cb_stepToButton);
    } // Fl_Button* stepToButton
    { Fl_Input* o = stepToAddressValuator = new Fl_Input(595, 685, 70, 25);
      stepToAddressValuator->textfont(4);
      stepToAddressValuator->callback((Fl_Callback*)cb_stepToAddressValuator);
      o->cursor_color(Fl_Color(3));
      o->value("0000");
    } // Fl_Input* stepToAddressValuator
    { stepOverButton = new Fl_Button(685, 685, 80, 25, "Step over");
      stepOverButton->selection_color(FL_LIGHT1);
      stepOverButton->callback((Fl_Callback*)cb_stepOverButton);
    } // Fl_Button* stepOverButton
    { stepButton = new Fl_Button(775, 685, 80, 25, "Step");
      stepButton->selection_color(FL_LIGHT1);
      stepButton->callback((Fl_Callback*)cb_stepButton);
    } // Fl_Button* stepButton
    { continueButton = new Fl_Button(865, 685, 80, 25, "Continue");
      continueButton->selection_color(FL_LIGHT1);
      continueButton->callback((Fl_Callback*)cb_continueButton);
    } // Fl_Button* continueButton
    window->size_range(920, 700, 1080, 810);
    window->end();
    window->resizable(window);
  } // Fl_Double_Window* window
}
