// generated by Fast Light User Interface Designer (fluid) version 1.0308

#ifndef debug_fl_hpp
#define debug_fl_hpp
#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Tabs.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Light_Button.H>
#include <FL/Fl_Text_Editor.H>
#include <FL/Fl_Value_Slider.H>
#include <FL/Fl_Choice.H>

class Plus4EmuGUI_DebugWindow {
public:
  friend class Plus4EmuGUIMonitor; 
  friend class Plus4EmuGUI_LuaScript; 
private:
  Plus4EmuGUI& gui; 
  char windowTitle[64]; 
  int savedWindowPositionX; 
  int savedWindowPositionY; 
  Fl_Widget *focusWidget; 
  Fl_Widget *prvTab; 
  uint32_t memoryDumpStartAddress; 
  uint32_t memoryDumpEndAddress; 
  uint32_t memoryDumpViewAddress; 
  uint32_t memoryDumpAddrDec; 
  uint32_t memoryDumpAddrInc; 
  bool memoryDumpCPUAddressMode; 
  bool memoryDumpASCIIFileFormat; 
  uint32_t disassemblyStartAddress; 
  uint32_t disassemblyViewAddress; 
  uint32_t disassemblyNextAddress; 
  Fl_Text_Buffer *bpEditBuffer; 
  Fl_Text_Buffer *scriptEditBuffer; 
  std::string breakPointLists[6]; 
  std::string tmpBuffer; 
  Plus4EmuGUI_LuaScript luaScript; 
  uint8_t prvTEDRegisterState[32]; 
public:
  Plus4EmuGUI_DebugWindow(Plus4EmuGUI& gui_); 
  ~Plus4EmuGUI_DebugWindow(); 
  void show(); 
  bool shown() const; 
  void hide(); 
  void activate(); 
  bool active() const; 
  void deactivate(double tt = 0.1); 
  bool breakPoint(int debugContext_, int type, uint16_t addr, uint8_t value); 
  void updateWindow(); 
private:
  char * printHexNumber(char *bufp, uint32_t n, size_t spaceCnt1, size_t nDigits, size_t spaceCnt2); 
  void dumpMemory(std::string& buf, uint32_t startAddr, uint32_t endAddr, uint32_t cursorAddr, bool showCursor, bool isCPUAddress); 
  void updateMemoryDumpDisplay(); 
  long parseHexNumber(uint32_t& value, const char *s); 
  void parseMemoryDump(const char *s); 
  void updateDisassemblyDisplay(); 
  uint32_t disassemblySearchBack(int insnCnt); 
  void applyBreakPointList(); 
  void setDebugContext(int n); 
public:
  static void breakPointCallback(void *userData, int debugContext_, int type, uint16_t addr, uint8_t value); 
private:
  static void hideWindowCallback(void *userData); 
  void createDebugWindow();
public:
  Fl_Double_Window *window;
private:
  inline void cb_window_i(Fl_Double_Window*, void*);
  static void cb_window(Fl_Double_Window*, void*);
public:
  Fl_Tabs *debugTabs;
private:
  inline void cb_debugTabs_i(Fl_Tabs*, void*);
  static void cb_debugTabs(Fl_Tabs*, void*);
public:
  Fl_Group *mainTab;
  Fl_Output *cpuRegisterDisplay;
  Fl_Output *memoryPagingDisplay;
  Fl_Output *stackMemoryDumpDisplay;
  Fl_Output *tedRegisterDisplay;
  Fl_Input *searchStringValuator;
private:
  inline void cb_searchStringValuator_i(Fl_Input*, void*);
  static void cb_searchStringValuator(Fl_Input*, void*);
  inline void cb_Find_i(Fl_Button*, void*);
  static void cb_Find(Fl_Button*, void*);
public:
  Plus4EmuGUI_ScrollableOutput *memoryDumpDisplay;
private:
  inline void cb_CPU_i(Fl_Light_Button*, void*);
  static void cb_CPU(Fl_Light_Button*, void*);
public:
  Fl_Input *memoryDumpStartAddressValuator;
private:
  inline void cb_memoryDumpStartAddressValuator_i(Fl_Input*, void*);
  static void cb_memoryDumpStartAddressValuator(Fl_Input*, void*);
public:
  Fl_Input *memoryDumpEndAddressValuator;
private:
  inline void cb_memoryDumpEndAddressValuator_i(Fl_Input*, void*);
  static void cb_memoryDumpEndAddressValuator(Fl_Input*, void*);
public:
  Fl_Button *memoryDumpPrvPageButton;
private:
  inline void cb_memoryDumpPrvPageButton_i(Fl_Button*, void*);
  static void cb_memoryDumpPrvPageButton(Fl_Button*, void*);
  inline void cb__i(Fl_Button*, void*);
  static void cb_(Fl_Button*, void*);
public:
  Fl_Button *memoryDumpNxtPageButton;
private:
  inline void cb_memoryDumpNxtPageButton_i(Fl_Button*, void*);
  static void cb_memoryDumpNxtPageButton(Fl_Button*, void*);
  inline void cb_ASCII_i(Fl_Light_Button*, void*);
  static void cb_ASCII(Fl_Light_Button*, void*);
  inline void cb_Load_i(Fl_Button*, void*);
  static void cb_Load(Fl_Button*, void*);
  inline void cb_Save_i(Fl_Button*, void*);
  static void cb_Save(Fl_Button*, void*);
public:
  Plus4EmuGUI_ScrollableOutput *disassemblyDisplay;
  Fl_Input *disassemblyStartAddressValuator;
private:
  inline void cb_disassemblyStartAddressValuator_i(Fl_Input*, void*);
  static void cb_disassemblyStartAddressValuator(Fl_Input*, void*);
public:
  Fl_Button *disassemblyPrvPageButton;
private:
  inline void cb_disassemblyPrvPageButton_i(Fl_Button*, void*);
  static void cb_disassemblyPrvPageButton(Fl_Button*, void*);
  inline void cb_1_i(Fl_Button*, void*);
  static void cb_1(Fl_Button*, void*);
public:
  Fl_Button *disassemblyNxtPageButton;
private:
  inline void cb_disassemblyNxtPageButton_i(Fl_Button*, void*);
  static void cb_disassemblyNxtPageButton(Fl_Button*, void*);
  inline void cb_PC_i(Fl_Button*, void*);
  static void cb_PC(Fl_Button*, void*);
public:
  Fl_Group *monitorTab;
  Plus4EmuGUIMonitor *monitor_;
  Fl_Text_Editor *breakPointEditor;
private:
  inline void cb_breakPointEditor_i(Fl_Text_Editor*, void*);
  static void cb_breakPointEditor(Fl_Text_Editor*, void*);
public:
  Fl_Value_Slider *bpPriorityThresholdValuator;
private:
  inline void cb_bpPriorityThresholdValuator_i(Fl_Value_Slider*, void*);
  static void cb_bpPriorityThresholdValuator(Fl_Value_Slider*, void*);
public:
  Fl_Light_Button *breakOnInvalidOpcodeValuator;
private:
  inline void cb_breakOnInvalidOpcodeValuator_i(Fl_Light_Button*, void*);
  static void cb_breakOnInvalidOpcodeValuator(Fl_Light_Button*, void*);
  inline void cb_Apply_i(Fl_Button*, void*);
  static void cb_Apply(Fl_Button*, void*);
  inline void cb_Load1_i(Fl_Button*, void*);
  static void cb_Load1(Fl_Button*, void*);
  inline void cb_Save1_i(Fl_Button*, void*);
  static void cb_Save1(Fl_Button*, void*);
public:
  Fl_Text_Editor *luaScriptEditor;
private:
  inline void cb_Load2_i(Fl_Button*, void*);
  static void cb_Load2(Fl_Button*, void*);
  inline void cb_Save2_i(Fl_Button*, void*);
  static void cb_Save2(Fl_Button*, void*);
  inline void cb_Insert_i(Fl_Button*, void*);
  static void cb_Insert(Fl_Button*, void*);
  inline void cb_Run_i(Fl_Button*, void*);
  static void cb_Run(Fl_Button*, void*);
  inline void cb_Stop_i(Fl_Button*, void*);
  static void cb_Stop(Fl_Button*, void*);
public:
  Fl_Choice *debugContextValuator;
private:
  inline void cb_debugContextValuator_i(Fl_Choice*, void*);
  static void cb_debugContextValuator(Fl_Choice*, void*);
public:
  Fl_Button *stepIntoButton;
private:
  inline void cb_stepIntoButton_i(Fl_Button*, void*);
  static void cb_stepIntoButton(Fl_Button*, void*);
public:
  Fl_Button *returnButton;
private:
  inline void cb_returnButton_i(Fl_Button*, void*);
  static void cb_returnButton(Fl_Button*, void*);
public:
  Fl_Button *stepToButton;
private:
  inline void cb_stepToButton_i(Fl_Button*, void*);
  static void cb_stepToButton(Fl_Button*, void*);
public:
  Fl_Input *stepToAddressValuator;
private:
  inline void cb_stepToAddressValuator_i(Fl_Input*, void*);
  static void cb_stepToAddressValuator(Fl_Input*, void*);
public:
  Fl_Button *stepOverButton;
private:
  inline void cb_stepOverButton_i(Fl_Button*, void*);
  static void cb_stepOverButton(Fl_Button*, void*);
public:
  Fl_Button *stepButton;
private:
  inline void cb_stepButton_i(Fl_Button*, void*);
  static void cb_stepButton(Fl_Button*, void*);
public:
  Fl_Button *continueButton;
private:
  inline void cb_continueButton_i(Fl_Button*, void*);
  static void cb_continueButton(Fl_Button*, void*);
};
#endif
